// EzScanVC4Dlg.cpp : TvC_CAO V1.0
#include "stdafx.h"
#include "EzScanVC4.h"
#include "EzScanVC4Dlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEzScanVC4Dlg _CAO

CEzScanVC4Dlg::CEzScanVC4Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CEzScanVC4Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CEzScanVC4Dlg)
	m_blShowUI = FALSE;
	m_iW = 0;
	m_iH = 0;
	m_iX = 0;
	m_iXDPI = 0;
	m_iY = 0;
	m_iYDPI = 0;
	m_blPage = FALSE;
	m_iPixelType = -1;
	//}}AFX_DATA_INIT
	// : LoadIcon  Win32  DestroyIcon ̃TuV[PXv܂B
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CEzScanVC4Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEzScanVC4Dlg)
	DDX_Control(pDX, IDC_CB_PIXELTYPE, m_cbPixelType);
	DDX_Control(pDX, IDC_EZSCANCTRL1, m_ctlEzScan);
	DDX_Check(pDX, IDC_CHK_SHOWUI, m_blShowUI);
	DDX_Text(pDX, IDC_ED_W, m_iW);
	DDX_Text(pDX, IDC_ED_H, m_iH);
	DDX_Text(pDX, IDC_ED_X, m_iX);
	DDX_Text(pDX, IDC_ED_XDPI, m_iXDPI);
	DDX_Text(pDX, IDC_ED_Y, m_iY);
	DDX_Text(pDX, IDC_ED_YDPI, m_iYDPI);
	DDX_Check(pDX, IDC_CHK_PAGE, m_blPage);
	DDX_CBIndex(pDX, IDC_CB_PIXELTYPE, m_iPixelType);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CEzScanVC4Dlg, CDialog)
	//{{AFX_MSG_MAP(CEzScanVC4Dlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_PB_SELECT_SCANNER, OnPbSelectScanner)
	ON_BN_CLICKED(IDC_PB_START_SCAN, OnPbStartScan)
	ON_BN_CLICKED(IDC_PB_ABOUT, OnPbAbout)
	ON_WM_SIZE()
	ON_BN_CLICKED(IDC_CHK_SHOWUI, OnChkShowui)
	ON_BN_CLICKED(IDC_CHK_PAGE, OnChkPage)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEzScanVC4Dlg bZ[W nh

BOOL CEzScanVC4Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	
	// ̃_CAOp̃ACRݒ肵܂Bt[[N̓AvP[ṼC
	// EBhE_CAOłȂ͎Iɐݒ肵܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACRݒ
	SetIcon(m_hIcon, FALSE);		// ACRݒ
	m_hBitmap = NULL;

	CDC *pcdc = GetDC();
	m_dc.CreateCompatibleDC(pcdc);
	ReleaseDC(pcdc);

	m_cbPixelType.AddString("TWPT_BW      0");
	m_cbPixelType.AddString("TWPT_GRAY    1");
	m_cbPixelType.AddString("TWPT_RGB     2");
	m_cbPixelType.AddString("TWPT_PALETTE 3");
	m_cbPixelType.AddString("TWPT_CMY     4");
	m_cbPixelType.AddString("TWPT_CMYK    5");
	m_cbPixelType.AddString("TWPT_YUV     6");
	m_cbPixelType.AddString("TWPT_YUVK    7");
	m_cbPixelType.AddString("TWPT_CIEXYZ  8");


	m_blShowUI = TRUE;
	m_iX = 0;
	m_iY = 0;
	m_iW = 5;
	m_iH = 5;
	m_iXDPI = 100;
	m_iYDPI = 100;
	m_blPage=FALSE;
	m_iPixelType = 0;
	UpdateData(FALSE);

typedef struct {
   short  MajorNum;  /* Major revision number of the software. */
   short  MinorNum;  /* Incremental revision number of the software. */
   short  Language;  /* e.g. TWLG_SWISSFRENCH */
   short  Country;   /* e.g. TWCY_SWITZERLAND */
   char   Info[32];      /* e.g. "1.0b3 Beta release" */
} TW_VERSION;
typedef struct {
   long  Id;              /* Unique number.  In Windows, app hWnd      */
   TW_VERSION Version;         /* Identifies the piece of code              */
   short  ProtocolMajor;   /* App and DS must set to TWON_PROTOCOLMAJOR */
   short  ProtocolMinor;   /* App and DS must set to TWON_PROTOCOLMINOR */
   long  SupportedGroups; /* Bit field OR combination of DG_ constants */
   char Manufacturer[32];    /* Manufacturer name, e.g. "Hewlett-Packard" */
   char   ProductFamily[32];   /* Product family name, e.g. "ScanJet"       */
   char   ProductName[32];     /* Product name, e.g. "ScanJet Plus"         */
} TW_IDENTITY;

	const TW_IDENTITY*sl = (TW_IDENTITY*)(LPCSTR)(m_ctlEzScan.GetScannerList(0));
	return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B
}

// _CAO{bNXɍŏ{^ǉȂ΁AACR`悷
// R[hȉɋLqKv܂BMFC AvP[V document/view
// fgĂ̂ŁȀ̓t[[Nɂ莩Iɏ܂B

void CEzScanVC4Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `p̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// NCAg̋`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR`悵܂B
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CPaintDC dc(this); // `p̃foCX ReLXg
		CWnd * poff = (CWnd*)GetDlgItem(IDC_TX_OFFSET);
		RECT rcpos,rcdlg;

		//`̈vZ
		poff->GetWindowRect(&rcpos);
		ScreenToClient(&rcpos);
		int x1 = rcpos.left;
		int y1 = rcpos.top;
		GetClientRect(&rcdlg);
		int x2 = rcdlg.right;
		int y2 = rcdlg.bottom;
		x2-=10;
		y2-=10;
		//`̈ɋ``
		dc.MoveTo(x1,y1);
		dc.LineTo(x2,y1);
		dc.LineTo(x2,y2);
		dc.LineTo(x1,y2);
		dc.LineTo(x1,y1);
		if(m_hBitmap){
			//ǂݍ݂Ă΁A摜`
			::SelectObject(m_dc.m_hDC,m_hBitmap);
			int w = x2-x1+1;
			int h = y2-y1+1;
			int pw = m_ctlEzScan.GetPixelWidth();//ǂݍ݉摜 
			int ph = m_ctlEzScan.GetPixelHeight();//ǂݍ݉摜 
			if(m_blPage)
				dc.StretchBlt(x1, y1, w, h, &m_dc, 0, 0, pw, ph, SRCCOPY);//`
			else
				dc.StretchBlt(x1, y1, w, h, &m_dc, 0, 0, w, h, SRCCOPY);//`
		}
		CDialog::OnPaint();
	}
}

// VXéA[U[ŏEBhEhbOĂԁA
// J[\\邽߂ɂĂяo܂B
HCURSOR CEzScanVC4Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}
//TCYύX
void CEzScanVC4Dlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	Invalidate();
}


BEGIN_EVENTSINK_MAP(CEzScanVC4Dlg, CDialog)
    //{{AFX_EVENTSINK_MAP(CEzScanVC4Dlg)
	ON_EVENT(CEzScanVC4Dlg, IDC_EZSCANCTRL1, 1 /* EndScan */, OnEndScanEzscanctrl1, VTS_I4 VTS_I4)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

//---------- EzScan.OCX֘A ------------
//ǂݍ݊̏
void CEzScanVC4Dlg::OnEndScanEzscanctrl1(long result, long page) 
{
	m_hBitmap = (HBITMAP)m_ctlEzScan.GetBitmap();//摜rbg}bṽnhۑ
	Invalidate();//ĕ`
}
//TWAIN\[XI
void CEzScanVC4Dlg::OnPbSelectScanner() 
{
	m_ctlEzScan.SelectScanner();
}
//ǂݍ݊Jn
void CEzScanVC4Dlg::OnPbStartScan() 
{
	UpdateData(TRUE);
	m_ctlEzScan.SetXOffset(m_iX);
	m_ctlEzScan.SetYOffset(m_iY);
	m_ctlEzScan.SetInchWidth(m_iW);
	m_ctlEzScan.SetInchHeight(m_iH);
	m_ctlEzScan.SetXdpi(m_iXDPI);
	m_ctlEzScan.SetYdpi(m_iYDPI);
	m_ctlEzScan.SetPixelType(m_iPixelType);
	m_ctlEzScan.StartScan(0);
}
//EzScan.OCX AboutBox()
void CEzScanVC4Dlg::OnPbAbout() 
{
	m_ctlEzScan.AboutBox();
	
}


void CEzScanVC4Dlg::OnChkShowui() 
{
	UpdateData(TRUE);
	m_ctlEzScan.SetShowUI(m_blShowUI);
	m_ctlEzScan.SetIndicator(m_blShowUI);
	
}

void CEzScanVC4Dlg::OnChkPage() 
{
	UpdateData(TRUE);	
	Invalidate();	
}
