// EzScanVC4Dlg.cpp : TvC_CAO V1.0
#include "stdafx.h"
#include "EzScanVC4.h"
#include "EzScanVC4Dlg.h"
#include "EzScanDef.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//#define DEBUG_BAND_MODE 1 //ݒ肷ƋNDS̃T[`sȂ(==NȂ)

/////////////////////////////////////////////////////////////////////////////
// CEzScanVC4Dlg _CAO

CEzScanVC4Dlg::CEzScanVC4Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CEzScanVC4Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CEzScanVC4Dlg)
	m_blShowUI = FALSE;
	m_iW = 0;
	m_iH = 0;
	m_iX = 0;
	m_iXDPI = 0;
	m_iY = 0;
	m_iYDPI = 0;
	m_blPage = FALSE;
	m_iPixelType = -1;
	m_iDepth = -1;
	m_iRepeat = 0;
	m_csScannerName = _T("");
	m_blLog = FALSE;
	m_csSaveFileName = _T("");
	m_blSave = FALSE;
	m_blADF = FALSE;
	m_csStartScanMode = _T("");
	m_iCont = 0;
	m_iBright = 0;
	m_blHist = FALSE;
	m_iThreshold = 0;
	m_blBrightTest = FALSE;
	m_blContTest = FALSE;
	m_blBurst = FALSE;
	m_iSCPara1 = 0;
	m_iSCPara2 = 0;
	m_edOp = 0;
	m_edID = 0;
	m_csGetCapRet = _T("");
	//}}AFX_DATA_INIT
	// : LoadIcon  Win32  DestroyIcon ̃TuV[PXv܂B
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CEzScanVC4Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEzScanVC4Dlg)
	DDX_Control(pDX, IDC_PB_SAMPLE, m_pbGoSample);
	DDX_Control(pDX, IDC_CHK_POMP, m_chkPomp);
	DDX_Control(pDX, IDC_ED_THRESHOLD, m_edThreshold);
	DDX_Control(pDX, IDC_SL_THRESHOLD, m_slThreshold);
	DDX_Control(pDX, IDC_SL_BRIGHT, m_slBright);
	DDX_Control(pDX, IDC_SL_CONT, m_slCont);
	DDX_Control(pDX, IDC_ED_CONT, m_edCont);
	DDX_Control(pDX, IDC_ED_BRIGHT, m_edBright);
	DDX_Control(pDX, IDC_ED_SAVE_FN, m_edSaveFileName);
	DDX_Control(pDX, IDC_CB_SCANNER, m_cbScanner);
	DDX_Control(pDX, IDC_TX_MSG1, m_ctlMsg1);
	DDX_Control(pDX, IDC_CB_DEPTH, m_cbDepth);
	DDX_Control(pDX, IDC_CB_PIXELTYPE, m_cbPixelType);
	DDX_Control(pDX, IDC_EZSCANCTRL1, m_ctlEzScan);
	DDX_Check(pDX, IDC_CHK_SHOWUI, m_blShowUI);
	DDX_Text(pDX, IDC_ED_W, m_iW);
	DDX_Text(pDX, IDC_ED_H, m_iH);
	DDX_Text(pDX, IDC_ED_X, m_iX);
	DDX_Text(pDX, IDC_ED_XDPI, m_iXDPI);
	DDX_Text(pDX, IDC_ED_Y, m_iY);
	DDX_Text(pDX, IDC_ED_YDPI, m_iYDPI);
	DDX_Check(pDX, IDC_CHK_PAGE, m_blPage);
	DDX_CBIndex(pDX, IDC_CB_PIXELTYPE, m_iPixelType);
	DDX_CBIndex(pDX, IDC_CB_DEPTH, m_iDepth);
	DDX_Text(pDX, IDC_ED_REPEAT, m_iRepeat);
	DDV_MinMaxInt(pDX, m_iRepeat, 1, 99999);
	DDX_CBString(pDX, IDC_CB_SCANNER, m_csScannerName);
	DDX_Check(pDX, IDC_CHK_LOG, m_blLog);
	DDX_Text(pDX, IDC_ED_SAVE_FN, m_csSaveFileName);
	DDV_MaxChars(pDX, m_csSaveFileName, 255);
	DDX_Check(pDX, IDC_CHK_SAVE, m_blSave);
	DDX_Check(pDX, IDC_CHK_ADF, m_blADF);
	DDX_CBString(pDX, IDC_CB_STARTSCANMODE, m_csStartScanMode);
	DDV_MaxChars(pDX, m_csStartScanMode, 3);
	DDX_Text(pDX, IDC_ED_CONT, m_iCont);
	DDV_MinMaxInt(pDX, m_iCont, -1000, 1000);
	DDX_Text(pDX, IDC_ED_BRIGHT, m_iBright);
	DDV_MinMaxInt(pDX, m_iBright, -1000, 1000);
	DDX_Check(pDX, IDC_CHK_HIST, m_blHist);
	DDX_Text(pDX, IDC_ED_THRESHOLD, m_iThreshold);
	DDV_MinMaxInt(pDX, m_iThreshold, 0, 255);
	DDX_Check(pDX, IDC_CHK_BRIGHT_TEST, m_blBrightTest);
	DDX_Check(pDX, IDC_CHK_CONT_TEST, m_blContTest);
	DDX_Check(pDX, IDC_CHK_BURST, m_blBurst);
	DDX_Text(pDX, IDC_ED_PARA1, m_iSCPara1);
	DDX_Text(pDX, IDC_ED_PARA2, m_iSCPara2);
	DDX_Text(pDX, IDC_ED_OP, m_edOp);
	DDX_Text(pDX, IDC_ED_ID, m_edID);
	DDX_Text(pDX, IDC_ED_GETCAP_RET, m_csGetCapRet);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CEzScanVC4Dlg, CDialog)
	//{{AFX_MSG_MAP(CEzScanVC4Dlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_PB_SELECT_SCANNER, OnPbSelectScanner)
	ON_BN_CLICKED(IDC_PB_START_SCAN, OnPbStartScan)
	ON_BN_CLICKED(IDC_PB_ABOUT, OnPbAbout)
	ON_WM_SIZE()
	ON_BN_CLICKED(IDC_CHK_SHOWUI, OnChkShowui)
	ON_BN_CLICKED(IDC_CHK_PAGE, OnChkPage)
	ON_BN_CLICKED(IDC_PB_SCANNER_INFO, OnPbScannerInfo)
	ON_BN_CLICKED(IDC_CHK_SAVE, OnChkSave)
	ON_WM_HSCROLL()
	ON_BN_CLICKED(IDC_PB_HIST, OnPbHist)
	ON_BN_CLICKED(IDC_CHK_POMP, OnChkPomp)
	ON_BN_CLICKED(IDC_PB_CANCEL, OnPbCancel)
	ON_BN_CLICKED(IDC_PB_SAMPLE, OnPbSample)
	ON_BN_CLICKED(IDC_PB_SET, OnPbSet)
	ON_BN_CLICKED(IDC_PB_GETCAP, OnPbGetcap)
	ON_BN_CLICKED(IDC_PB_SET_INT16, OnPbSetInt16)
	ON_BN_CLICKED(IDC_PB_CLOSE, OnPbClose)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEzScanVC4Dlg bZ[W nh

BOOL CEzScanVC4Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	
	// ̃_CAOp̃ACRݒ肵܂Bt[[N̓AvP[ṼC
	// EBhE_CAOłȂ͎Iɐݒ肵܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACRݒ
	SetIcon(m_hIcon, FALSE);		// ACRݒ
	m_hBitmap = NULL;
	m_hBitmapBand = NULL;

	CDC *pcdc = GetDC();
	m_dc.CreateCompatibleDC(pcdc);
	ReleaseDC(pcdc);

	m_cbPixelType.AddString("TWPT_BW      0");
	m_cbPixelType.AddString("TWPT_GRAY    1");
	m_cbPixelType.AddString("TWPT_RGB     2");
	m_cbPixelType.AddString("TWPT_PALETTE 3");
	m_cbPixelType.AddString("TWPT_CMY     4");
	m_cbPixelType.AddString("TWPT_CMYK    5");
	m_cbPixelType.AddString("TWPT_YUV     6");
	m_cbPixelType.AddString("TWPT_YUVK    7");
	m_cbPixelType.AddString("TWPT_CIEXYZ  8");

	m_cbDepth.AddString("0");
	m_cbDepth.AddString("1");
	m_cbDepth.AddString("4");
	m_cbDepth.AddString("8");
	m_cbDepth.AddString("24");

	m_blShowUI = TRUE;
	m_iX = 0;
	m_iY = 0;
	m_iW = 5;
	m_iH = 5;
	m_iXDPI = 100;
	m_iYDPI = 100;
	m_blPage=FALSE;
	m_iPixelType = 0;
	m_iDepth=0;
	m_iRepeat=1;
	m_blLog=FALSE;
#ifndef DEBUG_BAND_MODE
	for(int l = 0 ; ;l++){
		CString cs;
		cs = m_ctlEzScan.GetScannerList(l);
		if(cs.GetLength()==0)
			break;
		m_cbScanner.AddString(cs);
	}
#else
	m_blBurst=TRUE;
	m_ctlMsg1.SetWindowText("DEBUGp DEBUG_BAND_MODE`Ă܂");
#endif

	m_slThreshold.SetRange(0,255);
	m_slThreshold.SetPos(128);
	m_iThreshold = 128;
	m_slCont.SetRange(0,2000);
	m_slCont.SetPos(1000);
	m_slBright.SetRange(0,2000);
	m_slBright.SetPos(1000);
	UpdateData(FALSE);


	return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B
}

// _CAO{bNXɍŏ{^ǉȂ΁AACR`悷
// R[hȉɋLqKv܂BMFC AvP[V document/view
// fgĂ̂ŁȀ̓t[[Nɂ莩Iɏ܂B

void CEzScanVC4Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `p̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// NCAg̋`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR`悵܂B
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CPaintDC dc(this); // `p̃foCX ReLXg
		CWnd * poff = (CWnd*)GetDlgItem(IDC_TX_OFFSET);
		RECT rcpos,rcdlg;

		//`̈vZ
		poff->GetWindowRect(&rcpos);
		ScreenToClient(&rcpos);
		int x1 = rcpos.left;
		int y1 = rcpos.top;
		GetClientRect(&rcdlg);
		int x2 = rcdlg.right;
		int y2 = rcdlg.bottom;
		x2-=10;
		y2-=10;
		//`̈ɋ``
		dc.MoveTo(x1,y1);
		dc.LineTo(x2,y1);
		dc.LineTo(x2,y2);
		dc.LineTo(x1,y2);
		dc.LineTo(x1,y1);
		if(m_hBitmap){
			//ǂݍ݂Ă΁A摜`
			::SelectObject(m_dc.m_hDC,m_hBitmap);
			int w = x2-x1+1;
			int h = y2-y1+1;
			int pw = m_ctlEzScan.GetPixelWidth();//ǂݍ݉摜 
			int ph = m_ctlEzScan.GetPixelHeight();//ǂݍ݉摜 
			if(m_blPage)
				dc.StretchBlt(x1, y1, w, h, &m_dc, 0, 0, pw, ph, SRCCOPY);//`
			else
				dc.StretchBlt(x1, y1, w, h, &m_dc, 0, 0, w, h, SRCCOPY);//`
		}
		if(m_hBitmapBand){
			//ǂݍ݂Ă΁A摜`
			::SelectObject(m_dc.m_hDC,m_hBitmapBand);
			int w = x2-x1+1;
			int h = y2-y1+1;
			int pw = m_ctlEzScan.GetPixelWidth();//ǂݍ݉摜 
			int ph = m_ctlEzScan.GetPixelHeight();//ǂݍ݉摜 
			if(m_blPage)
				dc.StretchBlt(x1, y1, w, h, &m_dc, 0, 0, pw, ph, SRCCOPY);//`
			else
				dc.StretchBlt(x1, y1, w, h, &m_dc, 0, 0, w, h, SRCCOPY);//`
		}
		CDialog::OnPaint();
	}
}

// VXéA[U[ŏEBhEhbOĂԁA
// J[\\邽߂ɂĂяo܂B
HCURSOR CEzScanVC4Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}
//TCYύX
void CEzScanVC4Dlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	Invalidate();
}


BEGIN_EVENTSINK_MAP(CEzScanVC4Dlg, CDialog)
    //{{AFX_EVENTSINK_MAP(CEzScanVC4Dlg)
	ON_EVENT(CEzScanVC4Dlg, IDC_EZSCANCTRL1, 1 /* EndScan */, OnEndScanEzscanctrl1, VTS_I4 VTS_I4)
	ON_EVENT(CEzScanVC4Dlg, IDC_EZSCANCTRL1, 2 /* ClosedDS */, OnClosedDSEzscanctrl1, VTS_NONE)
	ON_EVENT(CEzScanVC4Dlg, IDC_EZSCANCTRL1, 3 /* BandBmp */, OnBandBmpEzscanctrl1, VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

//---------- EzScan.OCX֘A ------------
//ǂݍ݊̏
void CEzScanVC4Dlg::OnEndScanEzscanctrl1(long result, long page) 
{
	if((HBITMAP)m_ctlEzScan.GetBitmap()!=NULL){
		m_hBitmap = (HBITMAP)m_ctlEzScan.GetBitmap();//摜rbg}bṽnhۑ
		CString cs;
		m_iSaveCnt++;
		if(m_csSaveFileName.GetLength()>0){
			cs.Format("%s-%d",m_csSaveFileName,m_iSaveCnt);
			m_ctlEzScan.SetSaveFileName(cs);
		}
		Invalidate();//ĕ`
	}
	UpdateData(TRUE);
}
//TWAIN\[XI
void CEzScanVC4Dlg::OnPbSelectScanner() 
{
	m_ctlEzScan.SelectScanner();
}
//ǂݍ݊Jn
void CEzScanVC4Dlg::OnPbStartScan() 
{
	UpdateData(TRUE);
	OnChkShowui();

	
	if(m_hBitmap != NULL)
		DeleteObject(m_hBitmap);
	m_hBitmap=NULL;
	if(m_hBitmapBand != NULL)
		DeleteObject(m_hBitmapBand);
	m_hBitmapBand=NULL;

	m_iSaveCnt=0;
	m_iRepeatCnt = m_iRepeat;
	if(m_csScannerName.GetLength()>=0)
		m_ctlEzScan.SelectScannerName(m_csScannerName);

	//m_ctlEzScan.SetCap(SC_OP_DIS_SET_INDICATOR,1,NULL);//test

	m_ctlEzScan.SetAdf(m_blADF);
	m_ctlEzScan.SetSaveFile(m_blSave);
	m_ctlEzScan.SetSaveFileName(m_csSaveFileName);
	m_ctlEzScan.SetXOffset(m_iX);
	m_ctlEzScan.SetYOffset(m_iY);
	m_ctlEzScan.SetInchWidth(m_iW);
	m_ctlEzScan.SetInchHeight(m_iH);
	m_ctlEzScan.SetXdpi(m_iXDPI);
	m_ctlEzScan.SetYdpi(m_iYDPI);
	m_ctlEzScan.SetPixelType(m_iPixelType);
	m_ctlEzScan.SetLog(m_blLog);
	m_ctlEzScan.SetThreshold(m_iThreshold);
	m_ctlEzScan.SetContrast(m_iCont);
	m_ctlEzScan.SetBrightness(m_iBright);
	m_ctlEzScan.SetEnableHistgram(m_blHist);
	m_ctlEzScan.SetBandMode((m_blBurst)?1:0);
	m_ctlEzScan.StartScan(atoi((LPCSTR)m_csStartScanMode));
}
//EzScan.OCX AboutBox()
void CEzScanVC4Dlg::OnPbAbout() 
{
	m_ctlEzScan.AboutBox();
	
}


void CEzScanVC4Dlg::OnChkShowui() 
{
	UpdateData(TRUE);
	m_ctlEzScan.SetShowUI(m_blShowUI);
	m_ctlEzScan.SetIndicator(m_blShowUI);
	
}

void CEzScanVC4Dlg::OnChkPage() 
{
	UpdateData(TRUE);	
	Invalidate();	
}

void CEzScanVC4Dlg::OnPbScannerInfo() 
{
	char outbuf[256];

	UpdateData(TRUE);
	if(m_csScannerName.GetLength()>=0)
		m_ctlEzScan.SelectScannerName(m_csScannerName);
	m_ctlEzScan.GetCap(1,0, (BSTR*)outbuf) ;
	m_ctlEzScan.ScannerInfoDlg();	
}

void CEzScanVC4Dlg::OnClosedDSEzscanctrl1() 
{
	CString cs;
	cs.Format("XLI %d",m_iRepeatCnt);
	m_ctlMsg1.SetWindowText((LPCSTR)cs);

	if(m_blBrightTest){
		FILE *fp = fopen("c:\\tmp\\br.txt","a+");
		fprintf(fp,"%d,",m_iBright);
		int buf[256+2];
		m_ctlEzScan.GetCap(100,3,(BSTR*)buf);
		for(int c = 0 ; c < 256+2 ; c++){
			fprintf(fp,"%d,",buf[c]);
		}
		fprintf(fp,"\n");
		fclose(fp);
	}
	if(m_blContTest){
		FILE *fp = fopen("c:\\tmp\\cont.txt","a+");
		fprintf(fp,"%d,",m_iCont);
		int buf[256+2];
		m_ctlEzScan.GetCap(100,3,(BSTR*)buf);
		for(int c = 0 ; c < 256+2 ; c++){
			fprintf(fp,"%d,",buf[c]);
		}
		fprintf(fp,"\n");
		fclose(fp);
	}


	if(m_hBitmap!=0 && m_blShowUI==FALSE){
		m_iRepeatCnt--;
		if(m_iRepeatCnt>0){
			UpdateData(TRUE);
			m_ctlEzScan.SetXOffset(m_iX);
			m_ctlEzScan.SetYOffset(m_iY);
			m_ctlEzScan.SetInchWidth(m_iW);
			m_ctlEzScan.SetInchHeight(m_iH);
			m_ctlEzScan.SetXdpi(m_iXDPI);
			m_ctlEzScan.SetYdpi(m_iYDPI);
			m_ctlEzScan.SetPixelType(m_iPixelType);


//			m_ctlEzScan.SetThreshold(m_iThreshold);
//			m_ctlEzScan.SetContrast(m_iCont);
			if(m_blBrightTest){
				static int st = 100; 
				m_iBright += st;
				m_ctlEzScan.SetBrightness(m_iBright);
				UpdateData(FALSE);
			}
			if(m_blContTest){
				static int st = 100; 
				m_iCont += st;
				m_ctlEzScan.SetContrast(m_iCont);
				UpdateData(FALSE);
			}
			m_ctlEzScan.StartScan(atoi((LPCSTR)m_csStartScanMode));
		}
	}	
}

void CEzScanVC4Dlg::OnChkSave() 
{
	UpdateData(TRUE);
	if(m_blSave)
		m_edSaveFileName.EnableWindow(TRUE);
	else
		m_edSaveFileName.EnableWindow(FALSE);
}

void CEzScanVC4Dlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	char buf[100];
	if(pScrollBar==(CScrollBar*)&m_slThreshold){
		sprintf(buf,"%d",m_slThreshold.GetPos());
		m_edThreshold.SetWindowText(buf);
	}
	if(pScrollBar==(CScrollBar*)&m_slCont){
		sprintf(buf,"%d",m_slCont.GetPos()-1000);
		m_edCont.SetWindowText(buf);
	}
	if(pScrollBar==(CScrollBar*)&m_slBright){
		sprintf(buf,"%d",m_slBright.GetPos()-1000);
		m_edBright.SetWindowText(buf);
	}
	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CEzScanVC4Dlg::OnPbHist() 
{
	m_ctlEzScan.HistgramDlg();		
}

void CEzScanVC4Dlg::OnChkPomp() 
{
	if(m_chkPomp.GetCheck()==1)
		m_ctlEzScan.SetMsgPomp(1);
	else
		m_ctlEzScan.SetMsgPomp(0);
}

void CEzScanVC4Dlg::OnPbCancel() 
{
	m_ctlEzScan.CancelScan();	
}

void CEzScanVC4Dlg::OnPbSample() 
{
	m_ctlEzScan.SetGoSample(1);
	m_pbGoSample.EnableWindow(FALSE);	
}


void CEzScanVC4Dlg::OnBandBmpEzscanctrl1(long offset_y, long total_y, long width, long height, long hBitmap) 
{
	CDC *pcdc;
	pcdc = GetDC();
	//ǂݍ݂Ă΁A摜`
	if(offset_y==0){
		m_hBitmapBand = CreateCompatibleBitmap(pcdc->m_hDC, width, total_y);
	}
	::SelectObject(m_dc.m_hDC,m_hBitmapBand);

	CDC dcband;
	dcband.CreateCompatibleDC(pcdc);
	::SelectObject(dcband.m_hDC, (HBITMAP)hBitmap);
	m_dc.BitBlt(0,offset_y, width, height, &dcband, 0, 0, SRCCOPY);//`

	ReleaseDC(pcdc);	

	CWnd * poff = (CWnd*)GetDlgItem(IDC_TX_OFFSET);
	RECT rcpos,rcdlg;
	//`̈vZ
	poff->GetWindowRect(&rcpos);
	ScreenToClient(&rcpos);
	GetClientRect(&rcdlg);
	rcpos.right  = rcdlg.right;
	rcpos.bottom = rcdlg.bottom;
	InvalidateRect(&rcpos,FALSE);
}



void CEzScanVC4Dlg::OnPbGetcap() 
{
	UpdateData(TRUE);
	char buf[200];
	m_csGetCapRet = "";
	UpdateData(FALSE);
	m_ctlEzScan.GetCap(m_edOp,m_edID,(BSTR*)buf);
	m_csGetCapRet = buf;
	UpdateData(FALSE);
}

//Set BOOL
void CEzScanVC4Dlg::OnPbSet() 
{
	UpdateData(TRUE);
	//m_ctlEzScan.SetCap(m_iSCPara1,m_iSCPara2,NULL);
	char buf[100];
	sprintf(buf,"%d",m_iSCPara2);
	m_ctlEzScan.SetCap(SC_OP_SET_BOOL,m_iSCPara1,buf);
}
//Set int16
void CEzScanVC4Dlg::OnPbSetInt16() 
{
	UpdateData(TRUE);
	//m_ctlEzScan.SetCap(m_iSCPara1,m_iSCPara2,NULL);
	char buf[100];
	sprintf(buf,"%d",m_iSCPara2);
	m_ctlEzScan.SetCap(SC_OP_SET_INT16,m_iSCPara1,buf);
}

void CEzScanVC4Dlg::OnPbClose() 
{
	m_ctlEzScan.CloseDS();
	
}
