// AiEzScanDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "AiEzScan.h"
#include "AiEzScanDlg.h"
#include "Common.h"
#include "direct.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// CAiEzScanDlg _CAO

CAiEzScanDlg::CAiEzScanDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAiEzScanDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAiEzScanDlg)
	m_iPage = 0;
	m_csStatus = _T("");
	//}}AFX_DATA_INIT
	// : LoadIcon  Win32  DestroyIcon ̃TuV[PXv܂B
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CAiEzScanDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAiEzScanDlg)
	DDX_Control(pDX, IDC_CHK_CONFIG, m_chkConfig);
	DDX_Control(pDX, IDC_CHK_FOLDER, m_chkFolder);
	DDX_Control(pDX, IDC_EZSCANCTRL1, m_ezscan);
	DDX_Text(pDX, IDC_ED_PAGE, m_iPage);
	DDX_Text(pDX, IDC_TX_STATUS, m_csStatus);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAiEzScanDlg, CDialog)
	//{{AFX_MSG_MAP(CAiEzScanDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_PB_SCAN, OnPbScan)
	ON_BN_CLICKED(IDC_CHK_FOLDER, OnChkFolder)
	ON_BN_CLICKED(IDC_CHK_CONFIG, OnChkConfig)
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_START_SCAN,   OnMsgStartScan)
END_MESSAGE_MAP()



void CAiEzScanDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `p̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// NCAg̋`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR`悵܂B
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}
HCURSOR CAiEzScanDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


BOOL CAiEzScanDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	SetIcon(m_hIcon, TRUE);			// 傫ACRݒ
	SetIcon(m_hIcon, TRUE);		// ACRݒ

	m_iPage = 0;
	SetWindowText(APP_TITLE);//AvP[Ṽ^Cg̐ݒ


	{//XLĩ{^ɓo^邽߂STIɃAvP[Vo^(ʓrRg[pl̃XLĩvpeBŋN̐ݒKv)
		char buf[MAX_PATH];
		if (GetModuleFileName(NULL,buf,MAX_PATH)!=0){
			m_ezscan.STI(1/*Av̓o^*/, "AiEzScan", buf);
		}
	}

	//rbg}bv{^
	m_bmpFolder.LoadBitmap(IDB_FOLDER);
	m_chkFolder.SendMessage(BM_SETIMAGE,IMAGE_BITMAP,(long)(HANDLE)m_bmpFolder);
	m_bmpConfig.LoadBitmap(IDB_CONFIG);
	m_chkConfig.SendMessage(BM_SETIMAGE,IMAGE_BITMAP,(long)(HANDLE)m_bmpConfig);


	//STINꂽf
	//csSTIScannerName̒1ȏ̏ꍇ́ASTINꂽƂAN㒼ɃXLs
	CString csSTIScannerName = m_ezscan.STI(3/*STIN̎擾(XLi)*/, NULL,NULL);
	if(csSTIScannerName.GetLength()){
//		AfxMessageBox(csSTIScannerName);
	}
	CString csSTIButtonName = m_ezscan.STI(4/*STIN̎擾({^)*/, NULL,NULL);
	if(csSTIButtonName.GetLength()){
//		AfxMessageBox(csSTIButtonName);
	}

	DispStatus();//ݒ̕\
	UpdateData(FALSE);

	if(csSTIScannerName.GetLength())
		PostMessage(WM_START_SCAN,0,0);//N㒼ɃXLs
	// CG: ȉ̃ubN̓c[qg R|[lgɂĒǉ܂
	{
		// c[qg Rg[쐬܂
		m_tooltip.Create(this);
		m_tooltip.Activate(TRUE);
		m_tooltip.AddTool(GetDlgItem(IDC_PB_SCAN), "XLi摜ǂݍ݂܂");
		m_tooltip.AddTool(GetDlgItem(IDC_CHK_CONFIG), "ݒʂJ܂");
		m_tooltip.AddTool(GetDlgItem(IDC_CHK_FOLDER), "ۑtH_J܂");
	}
	return TRUE;
}

//WM_START_SCANbZ[WɂXL
LONG CAiEzScanDlg::OnMsgStartScan(unsigned int wParam,long lParam)
{
	OnPbScan();
	return 0;
}


//XLJn
void CAiEzScanDlg::OnPbScan() 
{
	UpdateData(TRUE);

	//XLi_CAO\̗Lݒ
	if(m_config.m_blDisableUI)
		m_ezscan.SetShowUI(FALSE);
	else
		m_ezscan.SetShowUI(TRUE);


	//ʃXL̗Lݒ
	#define SC_OP_SET_BOOL 200 //SetCap BOOL
	m_ezscan.SetCap(SC_OP_SET_BOOL, 0x1013/*CAP_DUPLEXENABLED*/,m_config.m_blDuplex?"1":"0");

	//`ce̎gpݒ
	m_ezscan.SetAdf(m_config.m_blADF);

	//ۑt@Cݒ
	m_ezscan.SetSaveFile(TRUE);
	m_ezscan.SetSaveFileName(GetSaveFileName());

	//ǂݍ݃TCYݒ
	m_ezscan.SetInchWidth(gstPaperInfo[m_config.m_iSelSize].width_mm/25.4);
	m_ezscan.SetInchHeight(gstPaperInfo[m_config.m_iSelSize].height_mm/25.4);

	//ǍFݒ
	if(m_config.m_iSelColor==0)
		m_ezscan.SetPixelType(2);//J[
	else
		m_ezscan.SetPixelType(1);//

	//Ǎ𑜓xݒ
	int dpi = gstDPIInfo[m_config.m_iSelDPI].dpi;
	m_ezscan.SetXdpi(dpi);
	m_ezscan.SetYdpi(dpi);

	//`ce̕ő̑҂Ԃݒ
	m_ezscan.SetADFWaitSec(1);

	m_iPage = 0;//ŃJEgNA

	UpdateData(FALSE);

	m_ezscan.StartScan(0);//XLJn
}



BEGIN_EVENTSINK_MAP(CAiEzScanDlg, CDialog)
    //{{AFX_EVENTSINK_MAP(CAiEzScanDlg)
	ON_EVENT(CAiEzScanDlg, IDC_EZSCANCTRL1, 1 /* EndScan */, OnEndScanEzscanctrl1, VTS_I4 VTS_I4)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

//Py[Wǂݎ̃Cxg
void CAiEzScanDlg::OnEndScanEzscanctrl1(long result, long page) 
{
	if(result==0){
		//G[ĂȂꍇ́Aۑt@CύXAŃJEg{P
		m_ezscan.SetSaveFileName(GetSaveFileName());
		m_iPage++;
		UpdateData(FALSE);
		{//fobOp
			static int cnt=0;
			if(cnt<100)
				PostMessage(WM_START_SCAN,0,0);//N㒼ɃXLs
			cnt++;
		}

	}
}

//ۑt@C̎擾
//Nbۑt@C쐬
char * CAiEzScanDlg::GetSaveFileName()
{
	strcpy(m_szSaveFile, (LPCSTR)(m_config.m_csSaveDir));
	trim_yen(m_szSaveFile);
	struct tm *newtime;
	time_t long_time;
	time( &long_time );                /* long ƂĎ擾 */
	newtime = localtime( &long_time ); /* nɕϊ */
	sprintf(m_szSaveFile+strlen(m_szSaveFile), "\\%0004dN%02d%02d-%02d%02d%02db.jpg",
		newtime->tm_year+1900, newtime->tm_mon+1, newtime->tm_mday,
		newtime->tm_hour, newtime->tm_min, newtime->tm_sec);
	return m_szSaveFile;
}

//ʉ̃Xe[^X\
void CAiEzScanDlg::DispStatus()
{
	m_csStatus.Format("%s %dDPI %s", gstPaperInfo[m_config.m_iSelSize].disp_name, gstDPIInfo[m_config.m_iSelDPI].dpi,
		(m_config.m_iSelColor==0)?"װ":"");
	UpdateData(FALSE);
}

//ۑtH_I[v
void CAiEzScanDlg::OnChkFolder() 
{
	m_chkFolder.SetCheck(0);
	CString cs;
	cs.Format("explorer.exe /e, \"%s\"",(LPCSTR)m_config.m_csSaveDir);
	int r =	WinExec((LPCSTR)cs, SW_NORMAL);		
}

//ݒ_CAOI[v
void CAiEzScanDlg::OnChkConfig() 
{
	m_chkConfig.SetCheck(0);
	m_config.DoModal();	
	if(m_config.m_csSaveDir.GetLength()>0){
		mkmkdir((char*)(LPCSTR)m_config.m_csSaveDir);//ۑtH_炩ߍ쐬
	}
	DispStatus();
}

BOOL CAiEzScanDlg::PreTranslateMessage(MSG* pMsg)
{
	// CG: ȉ̃ubN̓c[qg R|[lgɂĒǉ܂
	{
		// c[qgɂ̃bZ[W܂
		m_tooltip.RelayEvent(pMsg);
	}
	return CDialog::PreTranslateMessage(pMsg);	// CG: ȉ̃ubN̓c[qg R|[lgɂĒǉ܂
}
