// Config.cpp : ݒ_CAO
//

#include "stdafx.h"
#include "AiEzScan.h"
#include "Config.h"
#include "Common.h"
#include "direct.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


//ǍTCY
struct paper_info gstPaperInfo[]={
//, TCYmm, cTCYmm
	{"A4",210 ,297},
	{"A5",148 ,210},
	{"A6",105 ,148},
	{"A7",74  ,105},
	{"B5",182 ,257},
	{"B6",128 ,182},
	{"B7",91  ,128},
	{NULL,0,0}	//end of table
};

//ǂݍ݉𑜓x
struct dpi_info gstDPIInfo[]={
// DPI
	{ "300DPI ꂢ", 300},
	{ "150DPI ", 150},
	{ " 75DPI r", 75},
	{NULL,0}	//end of table
};


/////////////////////////////////////////////////////////////////////////////
// CConfig _CAO


CConfig::CConfig(CWnd* pParent /*=NULL*/)
	: CDialog(CConfig::IDD, pParent)
{
	//{{AFX_DATA_INIT(CConfig)
	m_blADF = FALSE;
	m_blDisableUI = FALSE;
	m_csSaveDir = _T("");
	m_iSelColor = -1;
	m_iSelDPI = -1;
	m_iSelSize = -1;
	m_blDuplex = FALSE;
	//}}AFX_DATA_INIT

	//iniݒǂݍ
	m_iSelSize = get_ini_int("Config","size",0);
	m_iSelDPI = get_ini_int("Config","dpi",0);
	m_iSelColor = get_ini_int("Config","color",0);

	m_blADF = get_ini_int("Config","adf",0);
	m_blDisableUI = get_ini_int("Config","disable_ui",0);
	m_blDuplex = get_ini_int("Config","duplex",0);
	{
		char szTmpPath[MAX_PATH];
		int len = GetTempPath(sizeof(szTmpPath),szTmpPath);
		m_csSaveDir = get_ini_string("Config","save_dir",szTmpPath);
	}
}


void CConfig::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CConfig)
	DDX_Control(pDX, IDC_CB_COLOR, m_cbColor);
	DDX_Control(pDX, IDC_CB_SIZE, m_cbSize);
	DDX_Control(pDX, IDC_CB_DPI, m_cbDPI);
	DDX_Check(pDX, IDC_CHK_ADF, m_blADF);
	DDX_Check(pDX, IDC_CHK_DISABLE_UI, m_blDisableUI);
	DDX_Text(pDX, IDC_ED_SAVE_DIR, m_csSaveDir);
	DDX_CBIndex(pDX, IDC_CB_COLOR, m_iSelColor);
	DDX_CBIndex(pDX, IDC_CB_DPI, m_iSelDPI);
	DDX_CBIndex(pDX, IDC_CB_SIZE, m_iSelSize);
	DDX_Control(pDX, IDC_EZSCANCTRL1, m_ezscan);
	DDX_Check(pDX, IDC_CHK_DUPLEX, m_blDuplex);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CConfig, CDialog)
	//{{AFX_MSG_MAP(CConfig)
	ON_BN_CLICKED(IDC_PB_CLOSE, OnPbClose)
	ON_BN_CLICKED(IDC_PB_SAVEDIR, OnPbSavedir)
	ON_BN_CLICKED(IDC_PB_SELECT, OnPbSelect)
	ON_BN_CLICKED(IDC_PB_DEL_STI, OnPbDelSti)
	ON_BN_CLICKED(IDC_PB_OPEN_SCANNER, OnPbOpenScanner)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CConfig bZ[W nh

BOOL CConfig::OnInitDialog() 
{
	CDialog::OnInitDialog();
	{//ǂݍ݃TCYݒR{{bNX̏
		for(int i =0 ; gstPaperInfo[i].disp_name!=NULL ; i++){
			char buf[100];
			sprintf(buf, "%s %d x %d [mm]", gstPaperInfo[i].disp_name, gstPaperInfo[i].width_mm, gstPaperInfo[i].height_mm); 
			m_cbSize.AddString(buf);
		}
		m_cbSize.SetCurSel(m_iSelSize);
	}
	{//DPIݒR{{bNX̏
		for(int i =0 ; gstDPIInfo[i].disp_name!=NULL ; i++){
			char buf[100];
			sprintf(buf, "%s", gstDPIInfo[i].disp_name); 
			m_cbDPI.AddString(buf);
		}
		m_cbDPI.SetCurSel(m_iSelDPI);
	}
	{//FݒR{{bNX̏
		m_cbColor.AddString("J[");
		m_cbColor.AddString("摜");
		m_cbColor.SetCurSel(m_iSelColor);
	}
	UpdateData(FALSE);
	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

//鏈
void CConfig::OnPbClose() 
{
	UpdateData(TRUE);
	//iniɏ
	write_ini_int("Config","size", m_cbSize.GetCurSel());
	write_ini_int("Config","dpi", m_cbDPI.GetCurSel());
	write_ini_int("Config","color", m_cbColor.GetCurSel());
	write_ini_int("Config","adf", m_blADF);
	write_ini_int("Config","disable_ui", m_blDisableUI);
	write_ini_int("Config","duplex", m_blDuplex);
	write_ini_string("Config","save_dir", (LPCSTR)m_csSaveDir);
	CDialog::OnOK();
}


//SHBrowseForFolder()pR[obN
int CALLBACK BrowseCB(HWND hwnd,UINT uMsg,LPARAM lParam,LPARAM lpData)
{
    if(uMsg==BFFM_INITIALIZED){
        SendMessage(hwnd,BFFM_SETSELECTION,(WPARAM)TRUE,lpData);
    }
    return 0;
}
//ۑtH_̎QƏ
void CConfig::OnPbSavedir() 
{
	UpdateData(TRUE);
	char buf[MAX_PATH] ;
	BROWSEINFO  br ;
	br.hwndOwner = this->m_hWnd;       // LEBhE 
	br.pidlRoot  = NULL ;     
	br.pszDisplayName = buf;
	br.lpszTitle      = "ۑtH_IĂ" ; 
	#define BIF_USENEWUI 0x0040
	br.ulFlags        = BIF_EDITBOX/*|BIF_VALIDATE*/| BIF_USENEWUI; 
	br.lpfn           = &BrowseCB;
	br.lParam         = (long)(LPCSTR)m_csSaveDir;
	LPITEMIDLIST  pidl = SHBrowseForFolder( & br ) ; // fBNgI
	if ( pidl != NULL)
	{
		char path[MAX_PATH] ;
		if ( SHGetPathFromIDList( pidl, path ) != FALSE )
		{
			if(strlen(path)>0){
				m_csSaveDir = path;
				UpdateData(FALSE);
			}
		}
		CoTaskMemFree(pidl);              //ITEMIDLIST̉(㏈)
	}
}

//XLȋI
void CConfig::OnPbSelect() 
{
	m_ezscan.SelectScanner();	
}

//STĨAvP[V̍폜
void CConfig::OnPbDelSti() 
{
	if(AfxMessageBox("XLĩ{^AvP[V폜܂H", MB_YESNO)==IDYES)
		m_ezscan.STI(2/*Av̍폜*/, "ACRvEzScan", NULL);
}

//XLĩ_CAOI[v
void CConfig::OnPbOpenScanner() 
{
	m_ezscan.SetShowUI(TRUE);
	m_ezscan.StartScan(0);
	
}
